
function DrawCurrencyBar()

		-- Main Parent window to hold all the elements
	wCurrencyBar = Turbine.UI.Window();
	wCurrencyBar:SetMinimumWidth(280);
	wCurrencyBar:SetMaximumWidth(SCREENWIDTH - 2);
	wCurrencyBar:SetSize(SETTINGS.CURRENCYBAR.WIDTH,31);
	wCurrencyBar:SetPosition(SETTINGS.CURRENCYBAR.X,SETTINGS.CURRENCYBAR.Y);
	wCurrencyBar:SetVisible(SETTINGS.CURRENCYBAR.VISIBLE);

	Onscreen(wCurrencyBar); -- Makes sure the window is still onscreen (perhaps user changed resolution since last playing)

	-- Background controls to hold the background images
	cCurrencyBarBackLeft = Turbine.UI.Control();
	cCurrencyBarBackLeft:SetParent(wCurrencyBar);
	cCurrencyBarBackLeft:SetSize(15,31);
	cCurrencyBarBackLeft:SetPosition(0,0);
	cCurrencyBarBackLeft:SetBlendMode(4);
	cCurrencyBarBackLeft:SetBackground(_IMAGES.BARBACK_LEFT);
	cCurrencyBarBackLeft:SetMouseVisible(false);
	cCurrencyBarBackLeft:SetVisible(SETTINGS.SHOWBACKGROUND);

	cCurrencyBarBackCenter = Turbine.UI.Control();
	cCurrencyBarBackCenter:SetParent(wCurrencyBar);
	cCurrencyBarBackCenter:SetSize(SETTINGS.CURRENCYBAR.WIDTH-30,31);
	cCurrencyBarBackCenter:SetPosition(15,0);
	cCurrencyBarBackCenter:SetBlendMode(4);
	cCurrencyBarBackCenter:SetBackground(_IMAGES.BARBACK_CENTER);
	cCurrencyBarBackCenter:SetMouseVisible(false);
	cCurrencyBarBackCenter:SetVisible(SETTINGS.SHOWBACKGROUND);

	cCurrencyBarBackRight = Turbine.UI.Control();
	cCurrencyBarBackRight:SetParent(wCurrencyBar);
	cCurrencyBarBackRight:SetSize(15,31);
	cCurrencyBarBackRight:SetPosition(SETTINGS.CURRENCYBAR.WIDTH-15,0);
	cCurrencyBarBackRight:SetBlendMode(4);
	cCurrencyBarBackRight:SetBackground(_IMAGES.BARBACK_RIGHT);
	cCurrencyBarBackRight:SetMouseVisible(false);
	cCurrencyBarBackRight:SetVisible(SETTINGS.SHOWBACKGROUND);


	lstCurrencyDisplay = Turbine.UI.ListBox();
	lstCurrencyDisplay:SetParent(wCurrencyBar);
	lstCurrencyDisplay:SetPosition(15,2);
	lstCurrencyDisplay:SetSize(wCurrencyBar:GetWidth()-45,18);
	--lstCurrencyDisplay:SetBackColor(Turbine.UI.Color(0.2,0.2,0.2));
	lstCurrencyDisplay:SetOrientation(Turbine.UI.Orientation.Horizontal);

	sbCurrencyBar = Turbine.UI.Lotro.ScrollBar();
	sbCurrencyBar:SetParent(wCurrencyBar);
	sbCurrencyBar:SetSize(lstCurrencyDisplay:GetWidth()-2,11);
	sbCurrencyBar:SetPosition(lstCurrencyDisplay:GetLeft(),lstCurrencyDisplay:GetTop()+lstCurrencyDisplay:GetHeight()-1);
	sbCurrencyBar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	sbCurrencyBar:SetVisible(false);
	lstCurrencyDisplay:SetHorizontalScrollBar(sbCurrencyBar);

	lstCurrencyDisplay.ItemAdded = function()
		btnRefresh:SetVisible(true);
	end

	btnRefresh = Turbine.UI.Control();
	btnRefresh:SetParent(wCurrencyBar);
	btnRefresh:SetSize(16,16);
	btnRefresh:SetPosition(lstCurrencyDisplay:GetLeft()+lstCurrencyDisplay:GetWidth()+5,lstCurrencyDisplay:GetTop()+1);
	btnRefresh:SetBackground(_IMAGES.REFRESHBUTTON_NORMAL);
	btnRefresh:SetBlendMode(4);
	btnRefresh:SetVisible(false);
	btnRefresh:SetToolTip(_TOOLTIPS.RESET[SETTINGS.LANGUAGE]);

	btnRefresh.AltMouseEnter = function(sender,args)
		btnRefresh:SetBackground(_IMAGES.REFRESHBUTTON_OVER);
	end

	btnRefresh.AltMouseLeave = function()
		btnRefresh:SetBackground(_IMAGES.REFRESHBUTTON_NORMAL);
	end

	btnRefresh.MouseClick = function()

		local tempMsg = MessageBox.Create(_LANG.RESET[SETTINGS.LANGUAGE],"MBYESNO");
		tempMsg.Prompt = function () -- Event executed when a button is pressed.
			if tempMsg:GetResponse() == "MBYES" then -- Tells you which button.
				ResetStartVals();
			end
		end
	end

	HandleBackground();

	-- Window events
	blMinDragging = false;
	minRelX = 0;
	minRelY = 0;

	wCurrencyBar.MouseDown = function (sender, args)
		blMinDragging = true;
		minRelX = args.X;
		minRelY = args.Y;
	end

	wCurrencyBar.MouseUp = function (sender, args)
		blMinDragging = false;
	end

	wCurrencyBar.MouseMove = function (sender, args)

		if blMinDragging == true then
			local curX = Turbine.UI.Display.GetMouseX();
			local curY = Turbine.UI.Display.GetMouseY();
			local scWidth = Turbine.UI.Display.GetWidth();
			local scHeight = Turbine.UI.Display.GetHeight();

			local curLeft = curX - minRelX;
			local curTop = curY - minRelY;

			if curLeft < 0 then curLeft = 0 end;
			if curLeft > (scWidth-wCurrencyBar:GetWidth()) then curLeft = scWidth-wCurrencyBar:GetWidth() end;
			if curTop < 0 then curTop = 0 end;
			if curTop > (scHeight-wCurrencyBar:GetHeight()) then curTop = scHeight-wCurrencyBar:GetHeight() end;

			wCurrencyBar:SetLeft(curLeft);
			wCurrencyBar:SetTop(curTop);

			gblMINWINLEFT = curLeft;
			gblMINWINTOP = curTop;
		end
	end

	wCurrencyBar.Closing = function()
		SETTINGS.CURRENCYBAR.VISIBLE = false;
	end

	wCurrencyBar.PositionChanged = function()
		SETTINGS.CURRENCYBAR.X = wCurrencyBar:GetLeft();
		SETTINGS.CURRENCYBAR.Y = wCurrencyBar:GetTop();
	end

	wCurrencyBar:SetWantsKeyEvents(true);

	wCurrencyBar.KeyDown = function (sender,args)
		if args.Action == 268435635 then -- handles F12 button

			if SETTINGS.SHOWSCREEN == false then
				wCurrencyBar:SetVisible(SETTINGS.CURRENCYBAR.VISIBLE);
				SETTINGS.SHOWSCREEN = true;
			else
				wCurrencyBar:SetVisible(false);
				wSettingsParent:SetVisible(false);
				SETTINGS.SHOWSCREEN = false;
			end
		end

		if args.Action == 145 then -- handles Esc button
			if wSettingsParent:IsVisible() == true then
				wSettingsParent:SetVisible(false);
			end
		end
	end

end


-- This function redraws the elements of the currency bar when a new currency is added to the tracker
function AddToBar(ITEMNAME)

	cItemContainer[ITEMNAME] = Turbine.UI.Control();
	cItemContainer[ITEMNAME]:SetHeight(lstCurrencyDisplay:GetHeight());
	cItemContainer[ITEMNAME]:SetMouseVisible(true);


	local imgCurrencyIcon = Turbine.UI.Control();
	imgCurrencyIcon:SetParent(cItemContainer[ITEMNAME]);
	imgCurrencyIcon:SetPosition(0,0);
	imgCurrencyIcon:SetBlendMode(4);
	imgCurrencyIcon:SetMouseVisible(false);


	if ITEMNAME == "MONEY" then
		imgCurrencyIcon:SetBackground(_IMAGES.SMLGOLDCOIN);
		imgCurrencyIcon:SetSize(27,21);
		cItemContainer[ITEMNAME]:SetToolTip(_TOOLTIPS.MONEY[SETTINGS.LANGUAGE]);
	else
		imgCurrencyIcon:SetBackground(tonumber(_ITEMS[ITEMNAME]["IMAGES"]["SMALL"]));
		imgCurrencyIcon:SetSize(16,16);
		cItemContainer[ITEMNAME]:SetToolTip(ITEMNAME);
	end

	lblQuantity[ITEMNAME] = Turbine.UI.TextBox();
	lblQuantity[ITEMNAME]:SetParent(cItemContainer[ITEMNAME]);
	lblQuantity[ITEMNAME]:SetPosition(imgCurrencyIcon:GetWidth()+2,2);
	lblQuantity[ITEMNAME]:SetSize(1,cItemContainer[ITEMNAME]:GetHeight());
	lblQuantity[ITEMNAME]:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft);
	lblQuantity[ITEMNAME]:SetMultiline(false);
	lblQuantity[ITEMNAME]:SetMouseVisible(false);
	lblQuantity[ITEMNAME]:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
	lblQuantity[ITEMNAME]:SetFontStyle(Turbine.UI.FontStyle.Outline);
	lblQuantity[ITEMNAME]:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	lblQuantity[ITEMNAME]:SetText("0");


	cItemContainer[ITEMNAME]:SetWidth(lblQuantity[ITEMNAME]:GetLeft()+lblQuantity[ITEMNAME]:GetWidth());

	if ITEMNAME == "MONEY" then
		lstCurrencyDisplay:InsertItem(0,cItemContainer[ITEMNAME]);
	else
		lstCurrencyDisplay:AddItem(cItemContainer[ITEMNAME]);

		-- Handle 'remove' Pop-up menu
		cItemContainer[ITEMNAME].MouseClick = function (sender, args)
			if args.Button == 2 then

				local contextMenu = Turbine.UI.ContextMenu();
				local menuItems = contextMenu:GetItems();

				local removeItem = Turbine.UI.MenuItem(_LANG.REMOVE[SETTINGS.LANGUAGE]);

				removeItem.Click = function ()
					local tempString = cItemContainer[ITEMNAME]:GetToolTip();
					chkDisplay[ITEMNAME]:SetChecked(false);
					--RemoveTrack(ITEMNAME);
					print(_LANG.NOTRACKING[SETTINGS.LANGUAGE] .. ": " .. tempString);
				end

				menuItems:Add(Turbine.UI.MenuItem(cItemContainer[ITEMNAME]:GetToolTip(),false));
				menuItems:Add(removeItem);

				contextMenu:ShowMenu();
			end
		end
	end

end


-- This function updates the displayed variances
function UpdateDisplay(ITEMNAME) --ITEMNAME as string

	if ITEMNAME == nil then return end;
	if ITEMNAME == "MONEY" then _ITEMS["MONEY"]["CHARACTERS"][CHARNAME]["DISPLAY"] = true end;

	-- Update the main currency tracker in the settings window.
	UpdateSettingsDisplay(ITEMNAME);

	-- Check if it should be displayed
	if _ITEMS[ITEMNAME]["CHARACTERS"][CHARNAME]["DISPLAY"] == nil then _ITEMS[ITEMNAME]["CHARACTERS"][CHARNAME]["DISPLAY"] = SETTINGS.AUTOADD end;
	if _ITEMS[ITEMNAME]["CHARACTERS"][CHARNAME]["DISPLAY"] == false then return end; -- exit function if not to be displayed

	-- Check if the display exists for this item, if not then create it.
	if cItemContainer[ITEMNAME] == nil then	AddToBar(ITEMNAME) end;


	local startVal = 0;
	local curVal = 0;


	if _ITEMS[ITEMNAME]["CHARACTERS"][CHARNAME]["QTY"] ~= nil then curVal = _ITEMS[ITEMNAME]["CHARACTERS"][CHARNAME]["QTY"] end;
	if _ITEMS[ITEMNAME]["CHARACTERS"]["SHARED"] ~= nil then curVal = _ITEMS[ITEMNAME]["CHARACTERS"]["SHARED"] end;
	if _SESSIONSTART[ITEMNAME] ~= nil then startVal = _SESSIONSTART[ITEMNAME] end;
	local variance = curVal-startVal;

	if variance == 0 then
		lstCurrencyDisplay:RemoveItem(cItemContainer[ITEMNAME]);
		cItemContainer[ITEMNAME] = nil;
		return;
	end

	-- Check if Money, use component output
	if ITEMNAME == "MONEY" then

		local sOutput = "";
		if variance < 0 then sOutput = sOutput .. "-" end;
		sOutput = sOutput .. GetMoneyString(variance);
		lblQuantity[ITEMNAME]:SetText(sOutput);

	else
		lblQuantity[ITEMNAME]:SetText(comma_value(variance));
	end


	-- Resize control
	AutoWidth(lblQuantity[ITEMNAME]);
	cItemContainer[ITEMNAME]:SetWidth(lblQuantity[ITEMNAME]:GetLeft()+lblQuantity[ITEMNAME]:GetWidth()+8);

	if variance < 0 then
		lblQuantity[ITEMNAME]:SetForeColor(Turbine.UI.Color.Crimson);
	else
		lblQuantity[ITEMNAME]:SetForeColor(Turbine.UI.Color.LimeGreen);
	end

end


-- This function redraws the bar when it has been resized
function ResizeBar(NEWWIDTH)

	if NEWWIDTH == nil then return end;

	local oldWidth = wCurrencyBar:GetWidth();
	wCurrencyBar:SetWidth(NEWWIDTH);
	local offset = math.floor((NEWWIDTH - oldWidth)/2);
	wCurrencyBar:SetLeft(wCurrencyBar:GetLeft()-offset);
	Onscreen(wCurrencyBar);

	lstCurrencyDisplay:SetWidth(NEWWIDTH-45);
	sbCurrencyBar:SetWidth(lstCurrencyDisplay:GetWidth()-2);
	btnRefresh:SetLeft(lstCurrencyDisplay:GetLeft()+lstCurrencyDisplay:GetWidth()+5);

	--cCurrencyBarBackLeft:SetLeft();
	cCurrencyBarBackCenter:SetWidth(NEWWIDTH-30);
	cCurrencyBarBackRight:SetLeft(NEWWIDTH-15);

	if wBarBack ~= nil and wBarBack:IsVisible() then
		wBarBack:SetLeft((NEWWIDTH/2)-100);
	end

end
