
function DrawLoadBar()

	wBarBack = Turbine.UI.Control();
	wBarBack:SetParent(wCurrencyBar);
	wBarBack:SetSize(200,18);
	wBarBack:SetPosition((wCurrencyBar:GetWidth()/2)-100,(wCurrencyBar:GetHeight()/2)-9);
	wBarBack:SetBackground(_IMAGES.PROGRESSBAR_BACK);
	wBarBack:SetBlendMode(4);
	wBarBack:SetToolTip(_TOOLTIPS.UNLOCK[SETTINGS.LANGUAGE]);

	wBarOverlay = Turbine.UI.Control();
	wBarOverlay:SetParent(wBarBack);
	wBarOverlay:SetSize(179,9);
	wBarOverlay:SetPosition(10,5);
	wBarOverlay:SetBackground(_IMAGES.PROGRESSBAR_OVERLAY);
	wBarOverlay:SetBlendMode(4);
	wBarOverlay:SetMouseVisible(false);

	imgLocked = Turbine.UI.Control();
	imgLocked:SetParent(wBarBack);
	imgLocked:SetSize(32,32);
	imgLocked:SetPosition((100-8),-15);
	imgLocked:SetBackground(_IMAGES.PADLOCK);
	imgLocked:SetBlendMode(4);
	imgLocked:SetMouseVisible(false);

	-- bypass countdown if clicked
	wBarBack.MouseClick = function()
		GameLoad();
	end

	UpdateLoadBar();

end


function UpdateLoadBar()

	STARTTIME = Turbine.Engine.GetGameTime();

	wBarBack.Update = function()

		local CURRENTTIME = Turbine.Engine.GetGameTime();
		local REMAINING = (STARTTIME + SETTINGS.LOADDELAY) - CURRENTTIME;
		wBarOverlay:SetWidth( 179 * (REMAINING/SETTINGS.LOADDELAY) );

		if CURRENTTIME > (STARTTIME + SETTINGS.LOADDELAY) then
			GameLoad();
		end
	end

	wBarBack:SetWantsUpdates(true);
end


function GameLoad()

	-- Only load if NOT in a session play
	if string.find(CHARNAME,"~") then
		local lblDisabled = Turbine.UI.Label();
		lblDisabled:SetParent(wCurrencyBar);
		lblDisabled:SetSize(wCurrencyBar:GetSize());
		lblDisabled:SetPosition(0,0);
		lblDisabled:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
		lblDisabled:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		lblDisabled:SetFontStyle(Turbine.UI.FontStyle.Outline);
		lblDisabled:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
		lblDisabled:SetForeColor(Turbine.UI.Color.Red);
		lblDisabled:SetText(_LANG.SESSIONPLAY[SETTINGS.LANGUAGE]);
	else
		LoadWallet();
		RegisterEvents();
		BuildFullList();
		btnTrackAll:SetVisible(true);
		btnTrackNone:SetVisible(true);
		if lstCurrencyDisplay:GetItemCount() > 0 then btnRefresh:SetVisible(true) end;
		Debug(_LANG.UNLOCKED[SETTINGS.LANGUAGE]);
	end

	wBarBack:SetWantsUpdates(false);
	wBarBack:SetVisible(false);
end
