
function DrawSettingsWindow()

	local HeaderColor = Turbine.UI.Color.LemonChiffon;
	local HeaderFont = Turbine.UI.Lotro.Font.Verdana14;

	wSettingsParent = Turbine.UI.Lotro.Window();
	wSettingsParent:SetSize(605,650);
	wSettingsParent:SetPosition(SETTINGS.SETTINGSWIN.X,SETTINGS.SETTINGSWIN.Y);
	wSettingsParent:SetText("Currency Tracker");
	wSettingsParent:SetVisible(false);

	wSettingsBack = Turbine.UI.Control();
	wSettingsBack:SetParent(wSettingsParent);
	wSettingsBack:SetSize(604,646);
	wSettingsBack:SetPosition(1,2);
	wSettingsBack:SetBlendMode(4);
	wSettingsBack:SetBackground(_IMAGES.SETTINGSBACK);
	wSettingsBack:SetMouseVisible(false);

	-- GOLD CONTROLS AND HEADERS ---------------------------------------------------------------------------------------------------
	lblCoinTitle = Turbine.UI.Label();
	lblCoinTitle:SetParent(wSettingsParent);
	lblCoinTitle:SetPosition(20,40);
	lblCoinTitle:SetSize(200,18);
	lblCoinTitle:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
	lblCoinTitle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	lblCoinTitle:SetFontStyle(Turbine.UI.FontStyle.Outline);
	lblCoinTitle:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	lblCoinTitle:SetText(_LANG.COIN[SETTINGS.LANGUAGE]);

	lblGoldStart = Turbine.UI.Label();
	lblGoldStart:SetParent(wSettingsParent);
	lblGoldStart:SetPosition(38,82);
	lblGoldStart:SetSize(110,18);
	lblGoldStart:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
	lblGoldStart:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblGoldStart:SetFontStyle(Turbine.UI.FontStyle.Outline);
	lblGoldStart:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	lblGoldStart:SetForeColor(Turbine.UI.Color.White);
	lblGoldStart:SetText("");

	lblHead_GoldStart = Turbine.UI.Label();
	lblHead_GoldStart:SetParent(wSettingsParent);
	lblHead_GoldStart:SetPosition(lblGoldStart:GetLeft(),lblGoldStart:GetTop()-22);
	lblHead_GoldStart:SetSize(110,18);
	lblHead_GoldStart:SetFont(HeaderFont);
	lblHead_GoldStart:SetForeColor(HeaderColor);
	lblHead_GoldStart:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblHead_GoldStart:SetText(_LANG.START[SETTINGS.LANGUAGE]);

	lblGoldPresent = Turbine.UI.Label();
	lblGoldPresent:SetParent(wSettingsParent);
	lblGoldPresent:SetPosition(lblGoldStart:GetLeft()+lblGoldStart:GetWidth()+28,lblGoldStart:GetTop());
	lblGoldPresent:SetSize(110,18);
	lblGoldPresent:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
	lblGoldPresent:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblGoldPresent:SetFontStyle(Turbine.UI.FontStyle.Outline);
	lblGoldPresent:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	lblGoldPresent:SetForeColor(lblGoldStart:GetForeColor());
	lblGoldPresent:SetText("");

	lblHead_GoldPresent = Turbine.UI.Label();
	lblHead_GoldPresent:SetParent(wSettingsParent);
	lblHead_GoldPresent:SetPosition(lblGoldPresent:GetLeft(),lblGoldPresent:GetTop()-22);
	lblHead_GoldPresent:SetSize(110,18);
	lblHead_GoldPresent:SetFont(HeaderFont);
	lblHead_GoldPresent:SetForeColor(HeaderColor);
	lblHead_GoldPresent:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblHead_GoldPresent:SetText(_LANG.CURRENT[SETTINGS.LANGUAGE]);

	lblGoldVariance = Turbine.UI.Label();
	lblGoldVariance:SetParent(wSettingsParent);
	lblGoldVariance:SetPosition(lblGoldPresent:GetLeft()+lblGoldPresent:GetWidth()+28,lblGoldPresent:GetTop());
	lblGoldVariance:SetSize(110,18);
	lblGoldVariance:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
	lblGoldVariance:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblGoldVariance:SetFontStyle(Turbine.UI.FontStyle.Outline);
	lblGoldVariance:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	lblGoldVariance:SetForeColor(lblGoldStart:GetForeColor());
	lblGoldVariance:SetText("");

	lblHead_GoldVariance = Turbine.UI.Label();
	lblHead_GoldVariance:SetParent(wSettingsParent);
	lblHead_GoldVariance:SetPosition(lblGoldVariance:GetLeft(),lblGoldVariance:GetTop()-22);
	lblHead_GoldVariance:SetSize(110,18);
	lblHead_GoldVariance:SetFont(HeaderFont);
	lblHead_GoldVariance:SetForeColor(HeaderColor);
	lblHead_GoldVariance:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblHead_GoldVariance:SetText(_LANG.VARIANCE[SETTINGS.LANGUAGE]);

	lblAllGold = Turbine.UI.Label();
	lblAllGold:SetParent(wSettingsParent);
	lblAllGold:SetPosition(lblGoldVariance:GetLeft()+lblGoldVariance:GetWidth()+31,lblGoldVariance:GetTop());
	lblAllGold:SetSize(110,18);
	lblAllGold:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
	lblAllGold:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblAllGold:SetFontStyle(Turbine.UI.FontStyle.Outline);
	lblAllGold:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	lblAllGold:SetForeColor(lblGoldStart:GetForeColor());
	lblAllGold:SetText("");

	lblHead_AllGold = Turbine.UI.Label();
	lblHead_AllGold:SetParent(wSettingsParent);
	lblHead_AllGold:SetPosition(lblAllGold:GetLeft(),lblAllGold:GetTop()-22);
	lblHead_AllGold:SetSize(110,18);
	lblHead_AllGold:SetFont(HeaderFont);
	lblHead_AllGold:SetForeColor(HeaderColor);
	lblHead_AllGold:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblHead_AllGold:SetText(_LANG.GOLDALLCHARS[SETTINGS.LANGUAGE]);

	-- LISTBOX AND HEADERS ---------------------------------------------------------------------------------------------------------

	lblBarterTitle = Turbine.UI.Label();
	lblBarterTitle:SetParent(wSettingsParent);
	lblBarterTitle:SetPosition(20,119);
	lblBarterTitle:SetSize(200,18);
	lblBarterTitle:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
	lblBarterTitle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	lblBarterTitle:SetFontStyle(Turbine.UI.FontStyle.Outline);
	lblBarterTitle:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	lblBarterTitle:SetText(_LANG.BARTERITEMS[SETTINGS.LANGUAGE]);

	lstCurrencyFull = Turbine.UI.ListBox();
	lstCurrencyFull:SetParent(wSettingsParent);
	lstCurrencyFull:SetPosition(25,160);
	lstCurrencyFull:SetSize(wSettingsParent:GetWidth()-63,300);

	sbCurrencyFull = Turbine.UI.Lotro.ScrollBar();
	sbCurrencyFull:SetParent(wSettingsParent);
	sbCurrencyFull:SetSize(11,lstCurrencyFull:GetHeight()-2);
	sbCurrencyFull:SetPosition(lstCurrencyFull:GetLeft()+lstCurrencyFull:GetWidth()+2,lstCurrencyFull:GetTop());
	sbCurrencyFull:SetOrientation(Turbine.UI.Orientation.Vertical);
	sbCurrencyFull:SetVisible(false);
	lstCurrencyFull:SetVerticalScrollBar(sbCurrencyFull);

	HeaderColor = Turbine.UI.Color.Orange;
	HeaderFont = Turbine.UI.Lotro.Font.Verdana14;

	--if SETTINGS.LANGUAGE == "GERMAN" then HeaderFont = Turbine.UI.Lotro.Font.Verdana12 end; -- Try if translations are too long to fit.

	lblHead_Start = Turbine.UI.Label();
	lblHead_Start:SetParent(wSettingsParent);
	lblHead_Start:SetPosition(275,lstCurrencyFull:GetTop()-20);
	lblHead_Start:SetSize(60,18);
	lblHead_Start:SetFont(HeaderFont);
	lblHead_Start:SetForeColor(HeaderColor);
	lblHead_Start:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	lblHead_Start:SetText(_LANG.START[SETTINGS.LANGUAGE]);

	lblHead_Current = Turbine.UI.Label();
	lblHead_Current:SetParent(wSettingsParent);
	lblHead_Current:SetPosition(345,lstCurrencyFull:GetTop()-20);
	lblHead_Current:SetSize(60,18);
	lblHead_Current:SetFont(HeaderFont);
	lblHead_Current:SetForeColor(HeaderColor);
	lblHead_Current:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	lblHead_Current:SetText(_LANG.CURRENT[SETTINGS.LANGUAGE]);

	lblHead_Var = Turbine.UI.Label();
	lblHead_Var:SetParent(wSettingsParent);
	lblHead_Var:SetPosition(445,lstCurrencyFull:GetTop()-20);
	lblHead_Var:SetSize(30,18);
	lblHead_Var:SetFont(HeaderFont);
	lblHead_Var:SetForeColor(HeaderColor);
	lblHead_Var:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	lblHead_Var:SetText(_LANG.VARIANCE[SETTINGS.LANGUAGE]);

	lblHead_Track = Turbine.UI.Label();
	lblHead_Track:SetParent(wSettingsParent);
	lblHead_Track:SetPosition(485,lstCurrencyFull:GetTop()-20);
	lblHead_Track:SetSize(60,18);
	lblHead_Track:SetFont(HeaderFont);
	lblHead_Track:SetForeColor(HeaderColor);
	lblHead_Track:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	lblHead_Track:SetText(_LANG.TRACK[SETTINGS.LANGUAGE]);

	btnTrackAll = Turbine.UI.Lotro.Button();
	btnTrackAll:SetParent(wSettingsParent);
	btnTrackAll:SetSize(20,20);
	btnTrackAll:SetPosition(lstCurrencyFull:GetLeft()+lstCurrencyFull:GetWidth()-(btnTrackAll:GetWidth()*2)-5,lstCurrencyFull:GetTop()+lstCurrencyFull:GetHeight()+20);
	btnTrackAll:SetText("+");
	btnTrackAll:SetToolTip(_TOOLTIPS.CHECKALL[SETTINGS.LANGUAGE]);
	btnTrackAll:SetVisible(false);
	btnTrackAll.Click = function()
		TrackAll(true);
	end

	btnTrackNone = Turbine.UI.Lotro.Button();
	btnTrackNone:SetParent(wSettingsParent);
	btnTrackNone:SetSize(20,20);
	btnTrackNone:SetPosition(btnTrackAll:GetLeft()+btnTrackAll:GetWidth()+5,btnTrackAll:GetTop());
	btnTrackNone:SetText("-");
	btnTrackNone:SetToolTip(_TOOLTIPS.UNCHECKALL[SETTINGS.LANGUAGE]);
	btnTrackNone:SetVisible(false);
	btnTrackNone.Click = function()
		TrackAll(false);
	end

	-- SETTINGS CONTROLS --------------------------------------------------------------------------------------------------------

	lblSettingsTitle = Turbine.UI.Label();
	lblSettingsTitle:SetParent(wSettingsParent);
	lblSettingsTitle:SetPosition(20,lstCurrencyFull:GetTop()+lstCurrencyFull:GetHeight()+19);
	lblSettingsTitle:SetSize(200,18);
	lblSettingsTitle:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
	lblSettingsTitle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	lblSettingsTitle:SetFontStyle(Turbine.UI.FontStyle.Outline);
	lblSettingsTitle:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	lblSettingsTitle:SetText(_LANG.SETTINGS[SETTINGS.LANGUAGE]);

	chkAutoAdd = Turbine.UI.Lotro.CheckBox();
	chkAutoAdd:SetParent(wSettingsParent);
	chkAutoAdd:SetPosition(30,lblSettingsTitle:GetTop()+lblSettingsTitle:GetHeight()+10);
	chkAutoAdd:SetSize(370,18);
	chkAutoAdd:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	chkAutoAdd:SetForeColor(Turbine.UI.Color.DarkKhaki);
	chkAutoAdd:SetText(" " .. _LANG.AUTOADD[SETTINGS.LANGUAGE]);
	chkAutoAdd:SetChecked(SETTINGS.AUTOADD);
	chkAutoAdd:SetToolTip(_TOOLTIPS.AUTOADD[SETTINGS.LANGUAGE]);

	chkAutoAdd.CheckedChanged = function ()
		SETTINGS.AUTOADD = chkAutoAdd:IsChecked();
	end

	chkShowBackground = Turbine.UI.Lotro.CheckBox();
	chkShowBackground:SetParent(wSettingsParent);
	chkShowBackground:SetPosition(30,chkAutoAdd:GetTop()+chkAutoAdd:GetHeight()+10);
	chkShowBackground:SetSize(370,18);
	chkShowBackground:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	chkShowBackground:SetForeColor(Turbine.UI.Color.DarkKhaki);
	chkShowBackground:SetText(" " .. _LANG.SHOWBACK[SETTINGS.LANGUAGE]);
	chkShowBackground:SetChecked(SETTINGS.SHOWBACKGROUND);

	chkShowBackground.CheckedChanged = function ()
		SETTINGS.SHOWBACKGROUND = chkShowBackground:IsChecked();
		HandleBackground();
	end

	txtLoadDelay = Turbine.UI.Lotro.TextBox();
	txtLoadDelay:SetParent(wSettingsParent);
	txtLoadDelay:SetPosition(30,chkShowBackground:GetTop()+chkShowBackground:GetHeight()+10);
	txtLoadDelay:SetSize(40,20);
	txtLoadDelay:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	txtLoadDelay:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	txtLoadDelay:SetText(SETTINGS.LOADDELAY);
	txtLoadDelay:SetSelectable(true);
	txtLoadDelay:SetToolTip(_TOOLTIPS.LOADDELAY[SETTINGS.LANGUAGE]);

	txtLoadDelay.FocusGained = function (sender,args)
		txtLoadDelay:SetWantsUpdates(true);
	end

	txtLoadDelay.FocusLost = function (sender,args)
		txtLoadDelay:SetWantsUpdates(false);
	end

	txtLoadDelay.Update = function (sender, args)
		if tostring(SETTINGS.LOADDELAY) ~= txtLoadDelay:GetText() then
			local tempLoadDelay = txtLoadDelay:GetText();
			tempLoadDelay = string.gsub(tempLoadDelay,"[%[%]%%%+%-%a%s%,%:%;%/%@%'%#]","");
			SETTINGS.LOADDELAY = tonumber(tempLoadDelay);
			txtLoadDelay:SetText(tempLoadDelay);
		end
	end

	lblLoadDelay = Turbine.UI.Label();
	lblLoadDelay:SetParent(wSettingsParent);
	lblLoadDelay:SetPosition(txtLoadDelay:GetLeft()+txtLoadDelay:GetWidth()+10,txtLoadDelay:GetTop());
	lblLoadDelay:SetSize(370,txtLoadDelay:GetHeight());
	lblLoadDelay:SetFont(chkAutoAdd:GetFont());
	lblLoadDelay:SetForeColor(chkAutoAdd:GetForeColor());
	lblLoadDelay:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	lblLoadDelay:SetText(_LANG.LOADDELAY[SETTINGS.LANGUAGE]);

	lblWidthDesc = Turbine.UI.Label();
	lblWidthDesc:SetParent(wSettingsParent);
	lblWidthDesc:SetSize(85,20);
	lblWidthDesc:SetPosition(30,txtLoadDelay:GetTop()+txtLoadDelay:GetHeight()+10);
	lblWidthDesc:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	lblWidthDesc:SetForeColor(Turbine.UI.Color.DarkKhaki);
	lblWidthDesc:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	lblWidthDesc:SetText(_LANG.WIDTH[SETTINGS.LANGUAGE]);

	imgScrollLeft = Turbine.UI.Control();
	imgScrollLeft:SetParent(wSettingsParent);
	imgScrollLeft:SetSize(24,24);
	imgScrollLeft:SetPosition(lblWidthDesc:GetLeft()+lblWidthDesc:GetWidth()+10,lblWidthDesc:GetTop());
	imgScrollLeft:SetBackground(_IMAGES.SCROLL_LEFT);
	imgScrollLeft:SetBlendMode(4);

	imgScrollCenter = Turbine.UI.Control();
	imgScrollCenter:SetParent(wSettingsParent);
	imgScrollCenter:SetSize(360,24);
	imgScrollCenter:SetPosition(imgScrollLeft:GetLeft()+imgScrollLeft:GetWidth(),imgScrollLeft:GetTop());
	imgScrollCenter:SetBackground(_IMAGES.SCROLL_CENTER);
	imgScrollCenter:SetBlendMode(4);

	imgScrollRight = Turbine.UI.Control();
	imgScrollRight:SetParent(wSettingsParent);
	imgScrollRight:SetSize(21,24);
	imgScrollRight:SetPosition(imgScrollCenter:GetLeft()+imgScrollCenter:GetWidth(),imgScrollCenter:GetTop());
	imgScrollRight:SetBackground(_IMAGES.SCROLL_RIGHT);
	imgScrollRight:SetBlendMode(4);

	sbWidth = Turbine.UI.Lotro.ScrollBar();
	sbWidth:SetParent(wSettingsParent);
	sbWidth:SetOrientation(Turbine.UI.Orientation.Horizontal);
	sbWidth:SetSize(373,8);
	sbWidth:SetPosition(imgScrollCenter:GetLeft()-8,lblWidthDesc:GetTop()+7);
	sbWidth:SetVisible(true);
	sbWidth:SetZOrder(200000);
	sbWidth:SetMaximum(wCurrencyBar:GetMaximumWidth());
	sbWidth:SetMinimum(wCurrencyBar:GetMinimumWidth());
	sbWidth:SetValue(SETTINGS.CURRENCYBAR.WIDTH);

	lblWidth = Turbine.UI.Label();
	lblWidth:SetParent(wSettingsParent);
	lblWidth:SetSize(40,20);
	lblWidth:SetPosition(sbWidth:GetLeft()+sbWidth:GetWidth()+25,lblWidthDesc:GetTop());
	lblWidth:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	lblWidth:SetForeColor(Turbine.UI.Color.DarkKhaki);
	lblWidth:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	lblWidth:SetText(SETTINGS.CURRENCYBAR.WIDTH .. "px");

	sbWidth.ValueChanged = function (sender,args)
		local newVal = sbWidth:GetValue();
		lblWidth:SetText(tostring(newVal) .. "px");
		SETTINGS.CURRENCYBAR.WIDTH = newVal;
		ResizeBar(newVal);
	end

	-- Mouse Events ---------------------------------------------------------------------------------------------------------------
	wSettingsParent.PositionChanged = function()
		SETTINGS.SETTINGSWIN.X = wSettingsParent:GetLeft();
		SETTINGS.SETTINGSWIN.Y = wSettingsParent:GetTop();
	end

end


function BuildFullList()

	lstCurrencyFull:ClearItems();

	--print(Turbine.Engine.GetCallStack());

	-- Rebuild the items list and put in order
	local _SortedList = {};

	for k,v in pairs (_ITEMS) do
		table.insert(_SortedList,k);
	end

	table.sort(_SortedList);

	lblCurrentQty = {};
	lblCurVariance = {};
	chkDisplay = {};

	-- Loop through the sorted items table to get all known currencies, whether the player has any or not.
	for k,v in pairs (_SortedList) do

		if v ~= "MONEY" then

			-- If the character has not discovered the currency yet, then create the table entry and set the qty to 0.
			if _ITEMS[v].CHARACTERS[CHARNAME] == nil then
				_ITEMS[v].CHARACTERS[CHARNAME] = {};
				_ITEMS[v]["CHARACTERS"][CHARNAME]["DISPLAY"] = SETTINGS.AUTOADD;

				if _ITEMS[v]["CHARACTERS"]["SHARED"] == nil then
					_ITEMS[v]["CHARACTERS"][CHARNAME]["QTY"] = 0;
				end
			end

			local cListLine = Turbine.UI.Control();
			cListLine:SetSize(lstCurrencyFull:GetWidth(),36);

			local imgLargeIcon = Turbine.UI.Control();
			imgLargeIcon:SetParent(cListLine);
			imgLargeIcon:SetSize(32,32);
			imgLargeIcon:SetPosition(2,2);
			imgLargeIcon:SetBlendMode(4);
			imgLargeIcon:SetBackground(tonumber(_ITEMS[v].IMAGES.NORMAL));

			local lblCurrencyName = Turbine.UI.Label();
			lblCurrencyName:SetParent(cListLine);
			lblCurrencyName:SetSize(200,32);
			lblCurrencyName:SetPosition(40,2);
			lblCurrencyName:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
			lblCurrencyName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
			lblCurrencyName:SetFontStyle(Turbine.UI.FontStyle.Outline);
			lblCurrencyName:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
			lblCurrencyName:SetText(v);

			local lblStartQty = Turbine.UI.Label();
			lblStartQty:SetParent(cListLine);
			lblStartQty:SetSize(60,32);
			lblStartQty:SetPosition(lblCurrencyName:GetLeft()+lblCurrencyName:GetWidth()+10,2);
			lblStartQty:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
			lblStartQty:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
			lblStartQty:SetFontStyle(Turbine.UI.FontStyle.Outline);
			lblStartQty:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);

			if _SESSIONSTART[v] ~= nil then
				lblStartQty:SetText(comma_value(_SESSIONSTART[v]));
			else
				lblStartQty:SetText("0");
			end

			lblCurrentQty[v] = Turbine.UI.Label();
			lblCurrentQty[v]:SetParent(cListLine);
			lblCurrentQty[v]:SetSize(60,32);
			lblCurrentQty[v]:SetPosition(lblStartQty:GetLeft()+lblStartQty:GetWidth()+10,2);
			lblCurrentQty[v]:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
			lblCurrentQty[v]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
			lblCurrentQty[v]:SetFontStyle(Turbine.UI.FontStyle.Outline);
			lblCurrentQty[v]:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);

			if _ITEMS[v].CHARACTERS.SHARED ~= nil then
				lblCurrentQty[v]:SetText(comma_value(_ITEMS[v].CHARACTERS.SHARED));
				lblCurrencyName:SetForeColor(Turbine.UI.Color.LimeGreen);
			else
				if _ITEMS[v].CHARACTERS[CHARNAME].QTY ~= nil then
					lblCurrentQty[v]:SetText(comma_value(_ITEMS[v].CHARACTERS[CHARNAME].QTY));
				else
					lblCurrentQty[v]:SetText("0");
				end
			end

			local startVal = 0;
			local curVal = 0;

			if _ITEMS[v]["CHARACTERS"][CHARNAME]["QTY"] ~= nil then curVal = _ITEMS[v]["CHARACTERS"][CHARNAME]["QTY"] end;
			if _ITEMS[v]["CHARACTERS"]["SHARED"] ~= nil then curVal = _ITEMS[v]["CHARACTERS"]["SHARED"] end;
			if _SESSIONSTART[v] ~= nil then startVal = _SESSIONSTART[v] end;

			local variance = curVal-startVal;

			lblCurVariance[v] = Turbine.UI.Label();
			lblCurVariance[v]:SetParent(cListLine);
			lblCurVariance[v]:SetSize(60,32);
			lblCurVariance[v]:SetPosition(lblCurrentQty[v]:GetLeft()+lblCurrentQty[v]:GetWidth()+10,2);
			lblCurVariance[v]:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
			lblCurVariance[v]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
			lblCurVariance[v]:SetFontStyle(Turbine.UI.FontStyle.Outline);
			lblCurVariance[v]:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
			lblCurVariance[v]:SetText(comma_value(variance));

			if variance < 0 then
				lblCurVariance[v]:SetForeColor(Turbine.UI.Color.Crimson);
			elseif variance > 0 then
				lblCurVariance[v]:SetForeColor(Turbine.UI.Color.LimeGreen);
			else
				lblCurVariance[v]:SetForeColor(Turbine.UI.Color.White);
			end

			chkDisplay[v] = Turbine.UI.Lotro.CheckBox();
			chkDisplay[v]:SetParent(cListLine);
			chkDisplay[v]:SetPosition(lblCurVariance[v]:GetLeft()+lblCurVariance[v]:GetWidth()+50,8);
			chkDisplay[v]:SetSize(18,18);
			chkDisplay[v]:SetChecked(_ITEMS[v]["CHARACTERS"][CHARNAME]["DISPLAY"]);
			chkDisplay[v]:SetText("");
			chkDisplay[v]:SetToolTip(_TOOLTIPS.TRACK[SETTINGS.LANGUAGE]);

			chkDisplay[v].CheckedChanged = function()
				_ITEMS[v]["CHARACTERS"][CHARNAME]["DISPLAY"] = chkDisplay[v]:IsChecked();

				if chkDisplay[v]:IsChecked() == true then
					UpdateDisplay(v);
				else
					RemoveTrack(v);
				end
			end

			lstCurrencyFull:AddItem(cListLine);

		else

			-- MONEY ---
			if _SESSIONSTART[v] ~= nil then
				lblGoldStart:SetText(GetMoneyString(_SESSIONSTART[v]));
			else
				lblGoldStart:SetText("0");
			end

			if _ITEMS[v].CHARACTERS[CHARNAME].QTY ~= nil then
				lblGoldPresent:SetText(GetMoneyString(_ITEMS[v].CHARACTERS[CHARNAME].QTY));
			else
				lblGoldPresent:SetText("0");
			end

			local startVal = 0;
			local curVal = 0;

			if _ITEMS[v]["CHARACTERS"][CHARNAME]["QTY"] ~= nil then curVal = _ITEMS[v]["CHARACTERS"][CHARNAME]["QTY"] end;
			if _SESSIONSTART[v] ~= nil then startVal = _SESSIONSTART[v] end;

			local variance = curVal-startVal;

			local sOutput = "";
			if variance < 0 then sOutput = "-" end;

			lblGoldVariance:SetText(sOutput .. GetMoneyString(variance));
			lblAllGold:SetText(GetMoneyString(GetAllGold()));

			lblGoldVariance:SetForeColor(Turbine.UI.Color.White);
		end
	end
end


-- This function handles an item that is no longer being tracked and removes it from the currency bar
function RemoveTrack(ITEMNAME)

	if ITEMNAME == nil or ITEMNAME == "MONEY" then return end;

	_ITEMS[ITEMNAME]["CHARACTERS"][CHARNAME]["DISPLAY"] = false;

	if cItemContainer[ITEMNAME] ~= nil then
		lstCurrencyDisplay:RemoveItem(cItemContainer[ITEMNAME]);
		cItemContainer[ITEMNAME] = nil;
	end

end


function UpdateSettingsDisplay(ITEMNAME)

	if ITEMNAME == nil then return end;

	local startVal = 0;
	local curVal = 0;

	if _ITEMS[ITEMNAME]["CHARACTERS"][CHARNAME]["QTY"] ~= nil then curVal = _ITEMS[ITEMNAME]["CHARACTERS"][CHARNAME]["QTY"] end;
	if _ITEMS[ITEMNAME]["CHARACTERS"]["SHARED"] ~= nil then curVal = _ITEMS[ITEMNAME]["CHARACTERS"]["SHARED"] end;
	if _SESSIONSTART[ITEMNAME] ~= nil then startVal = _SESSIONSTART[ITEMNAME] end;
	local variance = curVal-startVal;

	-- Check if Money, use component output
	if ITEMNAME == "MONEY" then

		lblGoldPresent:SetText(GetMoneyString(curVal));

		local sOutput = "";
		if variance < 0 then sOutput = sOutput .. "-" end;
		sOutput = sOutput .. GetMoneyString(variance);
		lblGoldVariance:SetText(sOutput);

		if variance < 0 then
			lblGoldVariance:SetForeColor(Turbine.UI.Color.Crimson);
		elseif variance > 0 then
			lblGoldVariance:SetForeColor(Turbine.UI.Color.LimeGreen);
		else
			lblGoldVariance:SetForeColor(Turbine.UI.Color.White);
		end

		lblAllGold:SetText(GetMoneyString(GetAllGold()));

	else

		if lblCurrentQty[ITEMNAME] == nil then return end;

		lblCurrentQty[ITEMNAME]:SetText(comma_value(curVal));
		lblCurVariance[ITEMNAME]:SetText(comma_value(variance));

		if variance < 0 then
			lblCurVariance[ITEMNAME]:SetForeColor(Turbine.UI.Color.Crimson);
		elseif variance > 0 then
			lblCurVariance[ITEMNAME]:SetForeColor(Turbine.UI.Color.LimeGreen);
		else
			lblCurVariance[ITEMNAME]:SetForeColor(Turbine.UI.Color.White);
		end

	end

end


-- This function is called when track/untrack all button is pressed.
function TrackAll(TRACK) -- TRACK must be a boolean value

	if type(TRACK) ~= "boolean" then return end;

	for k,v in pairs (chkDisplay) do
		v:SetChecked(TRACK);
	end
end
